Index: pjproject/trunk/tests/pjsua/scripts-recvfrom/301_timer_good_retry_after_422.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-recvfrom/301_timer_good_retry_after_422.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-recvfrom/301_timer_good_retry_after_422.py	(revision 2858)
@@ -0,0 +1,28 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+# Session timers retry after 422
+
+
+pjsua = "--null-audio sip:127.0.0.1:$PORT --timer-min-se 100 --timer-se 1000"
+
+# First INVITE with timer rejected with 422
+req1 = sip.RecvfromTransaction("INVITE with SE too small", 422,
+				include=["Session-Expires:\s*1000"], 
+				exclude=[],
+				resp_hdr=["Min-SE: 2000"],
+                expect="ACK sip"
+			  	)
+
+# New INVITE with SE >= Min-SE
+req2 = sip.RecvfromTransaction("Retrying with acceptable SE", 200,
+				include=["Session-Expires:\s*2000", "Min-SE:\s*2000"], 
+				exclude=[],
+				resp_hdr=["Session-Expires: 2000;refresher=uac"]
+			  	)
+
+
+recvfrom_cfg = sip.RecvfromCfg("Session timers retry after 422",
+			       pjsua, [req1, req2])
+
Index: pjproject/trunk/tests/pjsua/scripts-sendto/170_timer_required.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/170_timer_required.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/170_timer_required.py	(revision 2858)
@@ -0,0 +1,27 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+pjsua_args = "--null-audio --auto-answer 200 --use-timer --timer-min-se 90 --timer-se 1800"
+extra_headers = "Require: timer\nSupported: timer\nSession-Expires: 1800\n"
+include = ["Session-Expires: .*;refresher=.*"]
+exclude = []
+sendto_cfg = sip.SendtoCfg("Session Timer required", pjsua_args, sdp, 200, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
+
Index: pjproject/trunk/tests/pjsua/scripts-sendto/171_timer_initiated_by_uas.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/171_timer_initiated_by_uas.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/171_timer_initiated_by_uas.py	(revision 2858)
@@ -0,0 +1,36 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+# RFC 4028 Section 9:
+#   If the incoming request contains a Supported header field with a
+#   value 'timer' but does not contain a Session-Expires header, it means
+#   that the UAS is indicating support for timers but is not requesting
+#   one.  The UAS may request a session timer in the 2XX response by
+#   including a Session-Expires header field.  The value MUST NOT be set
+#   to a duration lower than the value in the Min-SE header field in the
+#   request, if it is present.
+   
+pjsua_args = "--null-audio --auto-answer 200 --use-timer --timer-min-se 90 --timer-se 1800"
+extra_headers = "Supported: timer\n"
+include = ["Session-Expires: .*;refresher=.*"]
+exclude = []
+sendto_cfg = sip.SendtoCfg("Session Timer initiated by UAS", pjsua_args, sdp, 200, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
+
Index: pjproject/trunk/tests/pjsua/scripts-sendto/172_timer_supported_but_not_used.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/172_timer_supported_but_not_used.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/172_timer_supported_but_not_used.py	(revision 2858)
@@ -0,0 +1,26 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+pjsua_args = "--null-audio --auto-answer 200"
+extra_headers = "Supported: timer\n"
+include = []
+exclude = ["Session-Expires:"]
+sendto_cfg = sip.SendtoCfg("Session Timer supported but not used", pjsua_args, sdp, 200, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
Index: pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_no_refresher.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_no_refresher.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_no_refresher.py	(revision 2858)
@@ -0,0 +1,26 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+pjsua_args = "--null-audio --auto-answer 200 --timer-min-se 90"
+extra_headers = "Supported: timer\nSession-Expires: 1800\n"
+include = ["Session-Expires:.*;refresher=ua[cs]"]
+exclude = []
+sendto_cfg = sip.SendtoCfg("Session Timer without specifying refresher", pjsua_args, sdp, 200, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
Index: pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_refresher_uac.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_refresher_uac.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_refresher_uac.py	(revision 2858)
@@ -0,0 +1,26 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+pjsua_args = "--null-audio --auto-answer 200 --timer-min-se 90"
+extra_headers = "Supported: timer\nSession-Expires: 1800;refresher=uac\n"
+include = ["Session-Expires:.*;refresher=ua[cs]"]
+exclude = []
+sendto_cfg = sip.SendtoCfg("Session Timer offer refresher uac", pjsua_args, sdp, 200, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
Index: pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_refresher_uas.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_refresher_uas.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/173_timer_offer_refresher_uas.py	(revision 2858)
@@ -0,0 +1,26 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+pjsua_args = "--null-audio --auto-answer 200 --timer-min-se 90"
+extra_headers = "Supported: timer\nSession-Expires: 1800;refresher=uas\n"
+include = ["Session-Expires:.*;refresher=ua[cs]"]
+exclude = []
+sendto_cfg = sip.SendtoCfg("Session Timer offer refresher uas", pjsua_args, sdp, 200, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
Index: pjproject/trunk/tests/pjsua/scripts-sendto/174_timer_se_too_small.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sendto/174_timer_se_too_small.py	(revision 2858)
+++ pjproject/trunk/tests/pjsua/scripts-sendto/174_timer_se_too_small.py	(revision 2858)
@@ -0,0 +1,26 @@
+# $Id$
+import inc_sip as sip
+import inc_sdp as sdp
+
+sdp = \
+"""
+v=0
+o=- 0 0 IN IP4 127.0.0.1
+s=pjmedia
+c=IN IP4 127.0.0.1
+t=0 0
+m=audio 4000 RTP/AVP 0 101
+a=rtpmap:0 PCMU/8000
+a=sendrecv
+a=rtpmap:101 telephone-event/8000
+a=fmtp:101 0-15
+"""
+
+pjsua_args = "--null-audio --auto-answer 200 --timer-min-se 2000 --timer-se 2000"
+extra_headers = "Supported: timer\nSession-Expires: 1800\n"
+include = ["Min-SE:\s*2000"]
+exclude = []
+sendto_cfg = sip.SendtoCfg("Session Timer SE too small", pjsua_args, sdp, 422, 
+			   extra_headers=extra_headers,
+			   resp_inc=include, resp_exc=exclude) 
+			   
